Description

History

#1 - 07/22/2021 09:55 AM - Vladimir Tsichevski

The following 4gl:

DEFINE VARIABLE hQuery AS HANDLE NO-UNDO.

DO WHILE hQuery:GET-NEXT() :

   MESSAGE "Hello".

   CATCH EXC AS java.io.IOException:

   END.

END.

 

Produces the following Java output:

         try

         {

            loopLabel0:

            ;

            while ((hQuery.unwrapQuery().getNext()).booleanValue())

;

            {

               message("Hello");

            }

         }

catch (java.io.IOException exc)

         {

            processCatch(() -> 

            {

            });

         }

 

Note the extra semicolon after the while(...) line, which breaks the program logic.

Also, the catch(..) line indentation is incorrect.

05/02/2024 1/4



#3 - 07/22/2021 11:43 AM - Constantin Asofiei

- Status changed from New to WIP

- Assignee set to Constantin Asofiei

Greg, please review this.  I'm not sure how correct it is:

### Eclipse Workspace Patch 1.0

#P p2j

Index: rules/convert/brew.xml

===================================================================

--- rules/convert/brew.xml    (revision 2944)

+++ rules/convert/brew.xml    (working copy)

@@ -448,6 +448,7 @@

       <rule>notCode.add(java.star_comment)</rule>

       <rule>notCode.add(java.skip)</rule>

       <rule>notCode.add(java.annotation)</rule>

+      <rule>notCode.add(java.label_def)</rule>

       <rule>!isRuntimeConfig()

          <rule>outputRoot = getConfigParameter("output-root")</rule>

@@ -761,7 +762,8 @@

                type != java.initializer   and

                type != java.star_comment  and

                type != java.indent_grp    and

-               (parent.type == java.block or parent.type == java.initializer              or

+               (type == java.kw_catch or 

+                parent.type == java.block or parent.type == java.initializer              or

                 parent.type == java.bogus or parent.type == java.indent_grp               or

                 (parent.type == java.kw_switch and childIndex > 0 and type != java.then)  or

                 (type == java.kw_break                                        and 

#4 - 07/22/2021 12:55 PM - Greg Shah

Code Review Patch #5558-3

I think it is correct.  No objections.

#5 - 07/22/2021 01:08 PM - Constantin Asofiei
Greg Shah wrote:

Code Review Patch #5558-3

I think it is correct.  No objections.

 

Thanks, the patch is in 3821c rev 12705.

#6 - 07/22/2021 01:15 PM - Greg Shah

- % Done changed from 0 to 100

- Status changed from WIP to Test

#7 - 07/23/2021 10:47 AM - Vladimir Tsichevski

- % Done changed from 100 to 50

- Status changed from Test to WIP

The fix in rev 12705 removes the extra semicolon after a label, but does not remove the extra semicolon after the while(..) line, which is the real

trouble.

#8 - 07/23/2021 12:21 PM - Constantin Asofiei

Can you work around this issue? This block doesn't convert properly, either:

if hquery <> then 

do:

   MESSAGE "Hello".

   CATCH EXC AS java.io.IOException:

   END.

end.

#9 - 07/23/2021 12:26 PM - Constantin Asofiei

Actually, the test above converts OK (I was missing the <> ? right-side operand).

The question about if you can work around this still stands.

#10 - 07/23/2021 02:00 PM - Vladimir Tsichevski

Constantin Asofiei wrote:

The question about if you can work around this still stands.
Do you mean the extra semicolon after the while(..) ? I can only fix this manually in the converted Java to be able to debug other problems, but I

cannot put the result into production.

#11 - 07/23/2021 02:09 PM - Constantin Asofiei

Vladimir Tsichevski wrote:

Do you mean the extra semicolon after the while(..) ? I can only fix this manually in the converted Java to be able to debug other problems, but I

cannot put the result into production.

 

Yes, I mean to find a way to write the code in 4GL to avoid this problem.

#12 - 07/23/2021 02:20 PM - Constantin Asofiei

This seems to work:

DO WHILE hQuery:GET-NEXT() :

   MESSAGE "Hello".

   do: 

      // execute Java code here

      CATCH EXC AS java.io.IOException:

         undo, throw new progress.lang.apperror("failed").

      END.

   end.

END.
